require 'xmlsimple'
require 'hashit'

module ActsAsAtdw
  class Client
    
    def initialize(options = {})
      @api_key = options[:api_key]
      Savon.configure do |config|
        config.log = false
      end
      @client = Savon::Client.new do
        wsdl.document = "http://national.atdw.com.au/soap/AustralianTourismWebService.asmx?WSDL"
      end
    end
  
    def query_product_records(options = {})
      
      api_key = @api_key
      
      response = @client.request "query_product_records" do
        soap.namespaces["xmlns:xsi"] = "http://www.w3.org/2001/XMLSchema-instance"
        soap.namespaces["xmlns:xsd"] = "http://www.w3.org/2001/XMLSchema"
        soap.namespaces["xmlns:soap"] = "http://schemas.xmlsoap.org/soap/envelope/"
        soap.body = {"DistributorKey" => "#{api_key}"}
        options.each do |key, value|
          soap.body[key] = value
        end
      end
      
      result = XmlSimple.xml_in(response.body[:query_product_records_response][:query_product_records_result].gsub("<?xml version=\"1.0\" encoding=\"utf-16\" ?>", ""))
      
      if result["error"] && result["error"] == ["No rows returned"]
        return []
      elsif result["product_distribution"]
        results = []
        
        result["product_distribution"].each do |result|
          results << Hashit.new(result["product_record"].first)
          #results << result
        end
        
        return results
      else
        return []
      end
      
    end
    
    def get_specific_product_record(options = {})
      api_key = @api_key
      
      response = @client.request "get_specific_product_record" do
        soap.namespaces["xmlns:xsi"] = "http://www.w3.org/2001/XMLSchema-instance"
        soap.namespaces["xmlns:xsd"] = "http://www.w3.org/2001/XMLSchema"
        soap.namespaces["xmlns:soap"] = "http://schemas.xmlsoap.org/soap/envelope/"
        soap.body = {"DistributorKey" => "#{api_key}"}
        options.each do |key, value|
          soap.body[key] = value
        end
      end
      
      result = XmlSimple.xml_in(response.body[:get_specific_product_record_response][:get_specific_product_record_result].gsub("<?xml version=\"1.0\" encoding=\"utf-16\" ?>", ""))
      
      if result["error"] && result["error"] == ["No rows returned"]
        return nil
      elsif result["product_distribution"]
        return result["product_distribution"].first
      else
        return nil
      end
      
    end
  
  end
end